Module java.base
Package java.security

## Enum DrbgParameters.Capability

- java.lang.Object
- - java.lang.Enum<DrbgParameters.Capability>
  - - java.security.DrbgParameters.Capability

- All Implemented Interfaces:
    `Serializable`, `Comparable<DrbgParameters.Capability>`, `Constable`
  Enclosing class:
    DrbgParameters

      public static enum DrbgParameters.Capability
      extends Enum<DrbgParameters.Capability>

  The reseedable and prediction resistance capabilities of a DRBG.

  When this object is passed to a `SecureRandom.getInstance()` call, it is the requested minimum capability. When it's returned from `SecureRandom.getParameters()`, it is the effective capability.

  Please note that while the `Instantiate_function` defined in NIST SP 800-90Ar1 only includes a `prediction_resistance_flag` parameter, the `Capability` type includes an extra value `RESEED_ONLY` because reseeding is an optional function. If `NONE` is used in an `Instantiation` object in calling the `SecureRandom.getInstance` method, the returned DRBG instance is not guaranteed to support reseeding. If `RESEED_ONLY` or `PR_AND_RESEED` is used, the instance must support reseeding.

  The table below lists possible effective values if a certain capability is requested, i.e.

  >      Capability requested = ...;
  >      SecureRandom s = SecureRandom.getInstance("DRBG",
  >              DrbgParameters(-1, requested, null));
  >      Capability effective = ((DrbgParametes.Initiate) s.getParameters())
  >              .getCapability();

  requested and effective capabilities
  Requested Value | Possible Effective Values
  --- | ---
  NONE | NONE, RESEED_ONLY, PR_AND_RESEED
  RESEED_ONLY | RESEED_ONLY, PR_AND_RESEED
  PR_AND_RESEED | PR_AND_RESEED

  A DRBG implementation supporting prediction resistance must also support reseeding.

  Since:
    9

- - ### Nested Class Summary

    - ### Nested classes/interfaces declared in class java.lang.Enum

      `Enum.EnumDesc<E extends Enum<E>>`

  - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `NONE` | Neither prediction resistance nor reseed.
    `PR_AND_RESEED` | Both prediction resistance and reseed.
    `RESEED_ONLY` | Reseed but no prediction resistance.

  - ### Method Summary

    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `supportsPredictionResistance()` | Returns whether this capability supports prediction resistance.
    `boolean` | `supportsReseeding()` | Returns whether this capability supports reseeding.
    `static DrbgParameters.Capability` | `valueOf​(String name)` | Returns the enum constant of this type with the specified name.
    `static DrbgParameters.Capability[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods declared in class java.lang.Enum

      `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods declared in class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### PR_AND_RESEED

          public static final DrbgParameters.Capability PR_AND_RESEED

      Both prediction resistance and reseed.

    - #### RESEED_ONLY

          public static final DrbgParameters.Capability RESEED_ONLY

      Reseed but no prediction resistance.

    - #### NONE

          public static final DrbgParameters.Capability NONE

      Neither prediction resistance nor reseed.

  - ### Method Detail

    - #### values

          public static DrbgParameters.Capability[] values()

      Returns an array containing the constants of this enum type, in the order they are declared.
      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static DrbgParameters.Capability valueOf​(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### supportsReseeding

          public boolean supportsReseeding()

      Returns whether this capability supports reseeding.
      Returns:
        `true` for `PR_AND_RESEED` and `RESEED_ONLY`, and `false` for `NONE`

    - #### supportsPredictionResistance

          public boolean supportsPredictionResistance()

      Returns whether this capability supports prediction resistance.
      Returns:
        `true` for `PR_AND_RESEED`, and `false` for `RESEED_ONLY` and `NONE`